#include "Secretary.h"

Secretary::Secretary(){
	color = GetColor(255, 255, 255);
	cursor = 0;
	bestParam = 1;
	for (int i = 0; i < MAXPERSON; i++)resultCount[i] = 0;
	default();
	personNum = settingData[PERSON];
	trialNum = settingData[TRIAL];
}

void Secretary::default(){
	settingData[MODE] = 0;
	settingData[PERSON] = 50;
	settingData[TRIAL] = 200000;
}

void Secretary::secretaryMain(){
	printSetting();
	input();
}

void Secretary::printSetting(){
	if (cursor < DEFAULT){
		DrawBox(160, cursor * 20, 280, (cursor + 1) * 20, GetColor(255, 0, 0), false);
		DrawString(140, cursor * 20, "", color);
		DrawString(280, cursor * 20, "", color);
	}
	else DrawBox(0, cursor * 20, 160, (cursor + 1) * 20, GetColor(255, 0, 0), false);

	DrawString(0, 0, "̗p`", color);
	DrawString(0, 20, "ʐڐl", color);
	DrawFormatString(160, 20, color, "%dl", settingData[PERSON]);
	DrawString(0, 40, "s", color);
	DrawFormatString(160, 40, color, "%d", settingData[TRIAL]);
	DrawString(0, 60, "ݒɖ߂", color);
	DrawString(0, 80, "ʐڊJn", color);
	DrawString(0, 140, "ʐڌʁicF1ʍ̗pAFp[^j", color);
	DrawString(0, 160, "ŗǂ̃p[^", color);
	DrawFormatString(160, 160, color, "%d", bestParam);
	DrawString(0, 180, "̎1ʍ̗p", color);
	DrawFormatString(160, 180, color, "%.2f%%", resultCount[bestParam - 1] * 100.0 / trialNum);

	if (settingData[MODE] == CUTOFF) {
		DrawString(160, 0, "Cutoff", color);
		DrawString(320, 0, "ŏk-1l̂āǍ̎b1ʂ̗p", color);
	}
	if (settingData[MODE] == SUCCESSIVE) {
		DrawString(160, 0, "Successive", color);
		DrawString(320, 0, "܂ł1ʂłȂlk-1ľ1", color);
	}
	if (settingData[MODE] == CANDIDATE) {
		DrawString(160, 0, "Candidate", color);
		DrawString(320, 0, "܂ł1ʂlkԖ", color);
	}
	if (settingData[MODE] == PROBABILITY) {
		DrawString(160, 0, "Probability", color);
		DrawString(320, 0, "b1ʂ[ʐڍϐl/Sl]ō̗p", color);
	}

	plotGraph();

	DrawString(0, 460, "iL[Fړ@EnterL[F@SpaceL[FʐڊJnj", color);
}

void Secretary::plotGraph(){
	max = -1;
	for (int i = 0; i < personNum; i++){
		if (resultCount[i] > max)max = resultCount[i];
	}

	DrawLine(70, 220, 70, 420, color, 2);
	DrawLine(70, 420, 570, 420, color, 2);
	DrawString(50, 420, "0", color);
	//DrawFormatString(20, 210, color, "%.2f", max * 1.0 / trialNum);
	//DrawString(20, 210, "m", color);
	//DrawFormatString(560, 430, color, "%d", personNum);
	//DrawString(540, 450, "p[^", color);

	for (int i = 1; i <= max * 10 / trialNum; i++){
		DrawLine(67, 420 - 20 * i * trialNum / max, 73, 420 - 20 * i * trialNum / max, color, 1);
		DrawFormatString(20, 410 - 20 * i * trialNum / max, color, "%.2f", i * 0.1);
	}
	temp = (int)(pow(10, (int)log10(personNum - 1)));
	for (int i = 1; i <= personNum / temp; i++){
		DrawLine(70 + 500 * temp * i / personNum, 417, 70 + 500 * temp * i / personNum, 423, color, 1);
		DrawFormatString(60 + 500 * temp * i / personNum, 430, color, "%d", temp * i);
	}

	if (max > 0){
		for (int i = 0; i < personNum; i++){
			DrawCircle(70 + 500 * (i + 1) / personNum, 420 - 200 * resultCount[i] / max, 1, color, true, 1);
		}
	}
}

void Secretary::input(){
	if (keyInputLong(KEY_INPUT_LEFT) == true){
		switch (cursor){
		case MODE:
			if (settingData[cursor] > 0)settingData[cursor]--;
			break;
		case PERSON:
			if (settingData[cursor] > 2)settingData[cursor] -= (int)pow(10, (int)log10(settingData[cursor] - 1));
			break;
		case TRIAL:
			if (settingData[cursor] > 1)settingData[cursor] -= (int)pow(10, (int)log10(settingData[cursor] - 1));
			break;
		default:
			break;
		}
	}

	if (keyInputLong(KEY_INPUT_RIGHT) == true){
		switch (cursor){
		case MODE:
			if (settingData[cursor] < PROBABILITY)settingData[cursor]++;
			break;
		case PERSON:
			if (settingData[cursor] < MAXPERSON)settingData[cursor] += (int)pow(10, (int)log10(settingData[cursor]));
			break;
		case TRIAL:
			if (settingData[cursor] < MAXTRIAL)settingData[cursor] += (int)pow(10, (int)log10(settingData[cursor]));
			break;
		default:
			break;
		}
	}

	if (keyInputLong(KEY_INPUT_UP) == true && cursor > 0)cursor--;

	if (keyInputLong(KEY_INPUT_DOWN) == true && cursor < START)cursor++;

	if (keyInputShort(KEY_INPUT_RETURN) == true || keyInputShort(KEY_INPUT_Z) == true){
		switch (cursor){
		case DEFAULT:
			default();
			break;
		case START:
			simulation();
			break;
		default:
			break;
		}
	}

	if (keyInputShort(KEY_INPUT_SPACE) == true){
		simulation();
	}
}

int Secretary::simulation(){
	FILE *fp;
	struct tm now;
	time_t longtime;
	std::string fname;
	std::string mode, month, day, hour, min, sec;

	longtime = time(NULL);
	localtime_s(&now, &longtime);

	if (settingData[MODE] == CUTOFF)mode = "cutoff";
	if (settingData[MODE] == SUCCESSIVE)mode = "successive";
	if (settingData[MODE] == CANDIDATE)mode = "candidate";
	if (settingData[MODE] == PROBABILITY)mode = "probability";

	if (now.tm_mon < 9)month = "0" + std::to_string(now.tm_mon + 1);
	else month = std::to_string(now.tm_mon + 1);
	if (now.tm_mday < 9)day = "0" + std::to_string(now.tm_mday);
	else day = std::to_string(now.tm_mday);
	if (now.tm_hour < 9)hour = "0" + std::to_string(now.tm_hour);
	else hour = std::to_string(now.tm_hour);
	if (now.tm_min < 9)min = "0" + std::to_string(now.tm_min);
	else min = std::to_string(now.tm_min);
	if (now.tm_sec < 9)sec = "0" + std::to_string(now.tm_sec);
	else sec = std::to_string(now.tm_sec);

	fname = mode + "_" + std::to_string(settingData[PERSON]) + "_" + std::to_string(settingData[TRIAL]) + "_" 
		+ std::to_string(1900 + now.tm_year) + month + day + hour + min + sec;

	//open output file
	if (fopen_s(&fp, (fname + ".csv").c_str(), "w") != 0){
		printf("file open error.\n");
		return -1;
	}
	printf("output -> %s\n", fname.c_str());

	personNum = settingData[PERSON];
	trialNum = settingData[TRIAL];

	for (int i = 1; i <= personNum; i++){//change param
		//reset count
		resultCount[i - 1] = 0;

		for (int j = 0; j < settingData[TRIAL]; j++){
			//random order setting
			randomizeOrder();

			//interview
			if (settingData[MODE] == CUTOFF)cutoff(i);
			if (settingData[MODE] == SUCCESSIVE)successive(i);
			if (settingData[MODE] == CANDIDATE)candidate(i);
			if (settingData[MODE] == PROBABILITY)probability(i);
		}
		printf("%d\n", resultCount[i - 1]);
	}

	//search best param
	max = -1;
	for (int i = 0; i < personNum; i++){
		if (resultCount[i] > max){
			max = resultCount[i];
			bestParam = i + 1;
		}
	}

	//write output file
	fprintf(fp, "Parameter,Count\n");
	for (int i = 0; i < personNum; i++){
		fprintf(fp, "%d,%d\n", i + 1, resultCount[i]);
	}
	fprintf(fp, "BestParameter,%d\n",bestParam);
	fprintf(fp, "BestProbability,%f\n", resultCount[bestParam - 1] * 100.0 / trialNum);
	fclose(fp);

	//save screen shot
	ClearDrawScreen();
	printSetting();
	SaveDrawScreen(0, 0, 640, 480, (fname + ".bmp").c_str());

	return 0;
}

void Secretary::randomizeOrder(){
	int rand;
	int rest = personNum;
	for (int i = 0; i < personNum; i++)order[i] = -1;//reset order

	while (rest > 0){
		rest--;
		rand = GetRand(rest);
		temp = 0;
		for (int i = 0; i < personNum; i++){
			if (order[i] == -1){
				if (temp == rand){
					order[i] = rest;
					break;
				}
				temp++;
			}
		}
	}
}

void Secretary::cutoff(int param){
	max = -1;

	for (int i = 0; i < param - 1; i++){
		if (order[i] > max)max = order[i];
	}

	for (int i = param - 1; i < personNum; i++){
		if (i == personNum - 1 && order[i] == personNum - 1){//last person
			resultCount[param - 1]++;
			break;
		}

		if (order[i] > max){
			if (order[i] == personNum - 1)resultCount[param - 1]++;//if best, count
			break;
		}
	}
}

void Secretary::successive(int param){
	max = -1;
	temp = 0;

	for (int i = 0; i < personNum; i++){
		if (i == personNum - 1 && order[i] == personNum - 1){//last person
			resultCount[param - 1]++;
			break;
		}
		
		if (order[i] < max)	temp++;
		else {
			if (temp < param - 1)max = order[i];//continue
			else{
				if (order[i] == personNum - 1)resultCount[param - 1]++;//if best, count
				break;
			}
		}
	}
}

void Secretary::candidate(int param){
	max = -1;
	temp = 0;

	for (int i = 0; i < personNum; i++){
		if (i == personNum - 1 && order[i] == personNum - 1){//last person
			resultCount[param - 1]++;
			break;
		}

		if (order[i] > max){
			temp++;
			if (temp < param)max = order[i];//continue
			else{
				if (order[i] == personNum - 1)resultCount[param - 1]++;//if best, count
				break;
			}
		}
	}
}

void Secretary::probability(int param){
	max = -1;

	for (int i = 0; i < personNum; i++){
		if (i == personNum - 1 && order[i] == personNum - 1){//last person
			resultCount[param - 1]++;
			break;
		}

		if (order[i] > max){
			max = order[i];
			if (GetRand(personNum - 1) <= i){
				if (order[i] == personNum - 1)resultCount[param - 1]++;//if best, count
				break;
			}
		}
	}
}