#pragma once

#include "General.h"
#include "KeyInput.h"

#define MAXPERSON 10000
#define MAXTRIAL 1000000

enum CURSOR{
	MODE = 0,
	PERSON = 1,
	TRIAL = 2,
	DEFAULT = 3,
	START = 4
};

enum MODE{
	CUTOFF = 0,
	SUCCESSIVE = 1,
	CANDIDATE = 2,
	PROBABILITY = 3
};

class Secretary: public KeyInput{
public:
	Secretary();
	void secretaryMain();
private:
	int temp;
	int color;
	int cursor;
	int settingData[3];
	int resultCount[MAXPERSON];
	int bestParam;
	int order[MAXPERSON];
	int personNum;
	int trialNum;
	int max;
	void default();
	void printSetting();
	void plotGraph();
	void input();
	int simulation();
	void randomizeOrder();
	void cutoff(int param);
	void successive(int param);
	void candidate(int param);
	void probability(int param);
};